SystemOrganization addCategory: #AgileTestingDays!
SystemOrganization addCategory: 'AgileTestingDays-Tests'!
SystemOrganization addCategory: 'AgileTestingDays-Tutorial'!

Tutorial subclass: #ATD2016Tutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AgileTestingDays-Tutorial'!

!ATD2016Tutorial class methodsFor: 'accessing' stamp: 'StephanEggermont 12/5/2016 14:10'!
title
	^'ATD2016: Teaching Driven Design'! !

!ATD2016Tutorial methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 12/7/2016 20:02'!
debuggerDriven
	^TutorialText new
	title: 'Debugger driven design';
	text: 
'In Smalltalk, objects know when they don''t
know something. When asked to do that, they
show a debugger explaining that they do not 
understand a message. The debugger supports
adding behavior (and classes) at that moment.

Exercise
Numbers don''t understand the cubed message.
Add a test case class asserting that 2 cubed equals 8.
Run the test and see it fail and open the debugger.
Create the method. Where in the class hierarchy 
should it be added?
'! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 19:31'!
fastFeedback
	^TutorialText new
	title: 'Fast feedback';
	text: 
'"Fast feedback enables fast learning"

Discuss
- when is that not true
- how fast can you go

';
children: #(pharo)
! !

!ATD2016Tutorial methodsFor: 'tools' stamp: 'StephanEggermont 12/7/2016 20:15'!
goalsExercise
	^ TutorialTestcase new
		title: 'Top-down';
		textTitle: 'TestCase';
		assignment:
'Feature: verify whether the company is sustainable

Given me and my colleague work here
When both of us are happy
Then the company is sustainable

Exercise

Run the test case (glasses icon)
Find the testcase implementation (implementors, browse)
This was just the happy case. Add a testcase verifying 
what happens when I''m not happy. 

This exercise is documented in this tutorial 
as the goalsExercise method of ATD2016Tutorial. 
Document the new testcase, add it as unhappyCase to the  
class and add it to my children
';
		smalltalkClass: VisualizeYourBDD;
		methodSelector: #testCompanyIsSustainable;
		children: #()! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 19:33'!
lateBinding
	^TutorialText new
	title: 'Late binding';
	text: 
'"Agility needs late binding"

With direct manipulation we have the fastest feedback. 
With very late binding we can come close.

Open a playground and do:

ATDMorph new openInWorld
browse the ATDMorph class

Exercise:
1 Change the titleString to show that it is the 2016 edition.
2 The class has duplication: both drawOn: and step: define the font to use.  
  Add a method titleFont that returns the font, and use that.
  How do you make the changes while keeping the system running?

Discuss:
What are the limits to direct manipulation? 
We need more than just feedback. What?
   
'! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 13:11'!
messageSending
	^TutorialText new
	title: 'Message sending';
	text: 
'A method is called by sending a message to an object,
the message receiver; it returns an object.

Unary message (no arguments)
Array new.
#(1 2 3) size.

Binary message (one argument named by one or more symbol characters)
3 + 4.
''Hello'', '' World''.

Keyword message (one or more arguments inserted in the message name)
''Smalltalk'' allButFirst: 5
3 to: 10 by: 2.

Precedence:
Parentheses > unary > binary > keyword
left to right

Cascading (sent multiple messages to the same receiver)
OrderedCollection new
  add: #abc;
  add: #def;
  add: #ghi.
(the value of the cascade is the value of the last message sent,
send yourself to return the receiver instead)
'! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 18:21'!
pharo
	^TutorialText new
	title: 'Pharo';
	text: 
'Pharo is a Smalltalk
A very simple language, with a large library

Everything is an object
Classes are objects too
Single inheritance between classes
Instance variables are protected
Methods are public
Blocks are lexical closures a.k.a. anonymous methods
Computation happens only via message sends (and variable assignment)
';
	children: #(syntax punctuation messageSending tools);
	yourself
! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 20:20'!
pullGoals
	^TutorialText new
	title: 'Pull-based';
	text: 
'"Pull goals into your software"

With outside-in testing (mocking) we can easier
develop top-down, defining the interfaces between
objects (and subsystems) first. 

Discuss:
This gives fast feedback on the expected interface,
and leaves a gap between mock and actual object.
How to deal with that?

';
children: #(goalsExercise)
! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 13:11'!
punctuation
	^TutorialText new
	title: 'Punctuation';
	text: 
'"comment"
''string''
#symbol unique string
$a the character a
12 2r1100 16rC twelve in decimal binary and hexadecimal
3.14 1.2e3 floating point numbers
. expression separator
; message cascade
:= assignment
^ return a result from a method
[  :parameter | expression ] code block with a parameter
|foo bar| declaration of two temporary variables
#(abc 123) literal array with the symbol #abc and the number 123
{ foo. 3+2 } dynamic array built from 2 expressions
'! !

!ATD2016Tutorial methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 12/7/2016 19:30'!
sunit
	^TutorialText new
	title: 'SUnit';
	text: 
'SUnit started the TDD revolution. 
It is a classical xUnit style framework.
Testcases are subclasses from TestCase,
and test methods start their name with test.
setUp and tearDown deal with commonalities for
all test methods.

Exercise:
- browse the testcase class SUnitStartedTheRevolution
  note its test are broken.
- fix the tests.';
	children: #(debuggerDriven)! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 13:11'!
syntax
	^TutorialText new
	title: 'Syntax';
	text: 
'Six reserved words:

nil  the undefined object
true, false  boolean objects
self  the receiver of the current message
super  the receiver in the superclass context
thisContext  the current invocation on the call stack
'! !

!ATD2016Tutorial methodsFor: 'instance creation' stamp: 'StephanEggermont 12/7/2016 17:41'!
teachingDrivenDesign
	^TutorialText new
	title: 'TDD done right';
	text: 
'TDD done right: teaching driven design

Fast feedback enables fast learning
Agility needs late binding
The debugger is a design tool
Pull goals into the software

By: 
  Stephan Eggermont @StOnSoftware

At: 
  AgileTD2016
';
	yourself
! !

!ATD2016Tutorial methodsFor: 'tools' stamp: 'StephanEggermont 12/7/2016 18:23'!
tools
	^TutorialText new
	title: 'Tools';
	text: 
'Cmd-b  browse a class
Cmd-m  implementors of a method
Cmd-n  senders of a message
shift-Enter  unified search

Editing

Cmd-s  save
Cmd-i  inspect
Cmd-d  do-it

Add a new method/class by overwriting an existing or the template
'! !

!ATD2016Tutorial methodsFor: 'tutorial' stamp: 'StephanEggermont 12/7/2016 19:31'!
tutorial
	^#(
	teachingDrivenDesign
	fastFeedback
	#lateBinding
	sunit
	pullGoals
)! !

Object subclass: #ATDCompany
	instanceVariableNames: 'employees'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AgileTestingDays-Tests'!

!ATDCompany commentStamp: 'StephanEggermont 12/5/2016 15:27' prior: 0!
Starting BDD from the goals down. The company wants to be sustainable!

!ATDCompany class methodsFor: 'accessing' stamp: 'StephanEggermont 12/5/2016 15:21'!
employees: aCollection
	^self new
		employees: aCollection;
		yourself! !

!ATDCompany methodsFor: 'accessing' stamp: 'StephanEggermont 12/5/2016 15:20'!
employees
	^ employees! !

!ATDCompany methodsFor: 'accessing' stamp: 'StephanEggermont 12/7/2016 18:03'!
employees: aCollection
	employees := aCollection! !

!ATDCompany methodsFor: 'testing' stamp: 'StephanEggermont 12/7/2016 17:29'!
isSustainable
	^employees noneSatisfy: [ :employee | employee isHappy not ] ! !

BabyMock2TestCase subclass: #VisualizeYourBDD
	instanceVariableNames: 'me company colleague'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AgileTestingDays-Tests'!

!VisualizeYourBDD methodsFor: 'initialization' stamp: 'StephanEggermont 12/5/2016 15:28'!
setUp
	me := protocol mock: 'Me'.
	colleague := protocol mock: 'Colleague'.
	
	company := ATDCompany employees: {me. colleague}.
		
	protocol visualize: company.! !

!VisualizeYourBDD methodsFor: 'exercise' stamp: 'StephanEggermont 12/7/2016 14:55'!
testCompanyIsSustainable
	protocol describe
		allow: me recv: #isHappy; => true;
		allow: colleague recv: #isHappy; => true.
	company isSustainable! !

TestCase subclass: #SUnitStartedTheRevolution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AgileTestingDays-Tests'!

!SUnitStartedTheRevolution methodsFor: 'accessing' stamp: 'StephanEggermont 12/5/2016 14:50'!
iAmGreen
	^Color green! !

!SUnitStartedTheRevolution methodsFor: 'tests' stamp: 'StephanEggermont 12/7/2016 18:46'!
testClassicalTDD
	self assert: 1+2 = 4! !

!SUnitStartedTheRevolution methodsFor: 'tests' stamp: 'StephanEggermont 12/5/2016 14:50'!
testMoreClassicalTDD
	self assert: self iAmGreen! !

Morph subclass: #ATDMorph
	instanceVariableNames: 'textColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AgileTestingDays-Tests'!

!ATDMorph commentStamp: 'StephanEggermont 12/5/2016 16:07' prior: 0!
A visual object showing how life editing can be done!

!ATDMorph methodsFor: 'initialize' stamp: 'StephanEggermont 12/5/2016 15:51'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 130 @ 30! !

!ATDMorph methodsFor: 'initialize' stamp: 'StephanEggermont 12/5/2016 15:48'!
defaultColor
	^ Color yellow! !

!ATDMorph methodsFor: 'drawing' stamp: 'StephanEggermont 12/7/2016 18:27'!
defaultTextColor
	^ Smalltalk ui theme textColor. 
! !

!ATDMorph methodsFor: 'drawing' stamp: 'StephanEggermont 12/7/2016 18:34'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas drawString: self titleString
		in: (self bounds insetBy: (Margin left: 4 top: 6 right: 2 bottom: 2)) 
		font: (LogicalFont familyName: 'Source Sans Pro' pointSize: 10)
		color: self defaultTextColor. 
! !

!ATDMorph methodsFor: 'stepping and presenter' stamp: 'StephanEggermont 12/7/2016 18:11'!
step
	self width: ((LogicalFont familyName: 'Source Sans Pro' pointSize: 10) widthOfString: self titleString)+8.
	self bounds: (self bounds translateBy: 1@1).
	self bounds left > 100 ifTrue: [ self position: 0@0 ]! !

!ATDMorph methodsFor: 'model - stepping' stamp: 'StephanEggermont 12/5/2016 15:58'!
stepTime
	^ 200! !

!ATDMorph methodsFor: 'accessing' stamp: 'StephanEggermont 12/7/2016 18:28'!
textColor: aColor 
	textColor := aColor! !

!ATDMorph methodsFor: 'drawing' stamp: 'StephanEggermont 12/7/2016 18:10'!
titleString
	^'Agile Testing Days'
! !
